# -*- coding: utf-8 -*-
import sys, re, json, ssl
from bs4 import BeautifulSoup
try:
    from urllib2 import urlopen, Request
except ImportError:
    from urllib.request import urlopen, Request
try:
    from urlparse import urlparse, urljoin, parse_qs
except ImportError:
    from urllib.parse import urlparse, urljoin, parse_qs
ua = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/94.0.4606.71 Safari/537.36'


def httpget(url):
    ssl._create_default_https_context = ssl._create_unverified_context
    request = Request(url, headers={'User-Agent': ua})
    content = urlopen(request).read()
    try:
        return content.decode('utf-8')
    except UnicodeDecodeError:
        return content.decode('gbk')


def htmlparser(content):
    if (2, 7, 3) <= sys.version_info < (3, 0) or (3, 2) <= sys.version_info < (4, 0):
        return BeautifulSoup(content, 'html.parser')
    return BeautifulSoup(content, 'html5lib')


def category(page=1):
    url = 'https://t66y.com/thread0806.php?fid=22&page=%d' % page
    o = urlparse(url)
    q = parse_qs(o.query)
    if 'page' in q:
        page = int(q['page'][0])
    else:
        page = 1
    try:
        content = httpget(url)
    except Exception as e:
        return {'code': 't66y 100', 'error': str(e)}
    ret = []
    soup = htmlparser(content)
    for e in soup.select('tr.tr3'):
        e1 = e.select('td.tal')
        if not e1:
            continue
        e1 = e1[0]
        title = e1.text.strip()
        if ord(title[0]) == 8593:
            continue
        e2 = e1.select('h3 a')
        if not e2:
            continue
        e2 = e2[0]
        title = e.select('a.bl')[0].text.strip()
        title += ' ' + e2.text.strip()
        ret.append({'title': title, 'url': urljoin(url, e2['href'])})
    total = soup.select('a#last')
    if total:
        total = total[0]
        total = int(total['href'].split('=')[-1])
        if page < total:
            ret.append({'title': 'Next Page (%d/%d)' % (page + 1, total), 'category': '', 'page': page + 1})
    return ret


def test2(url, purl=None):
    import xbmcgui
    o = urlparse(url)
    p = o.path.split('/')
    while p and not p[-1]:
        p = p[:-1]
    q = parse_qs(o.query)
    # https://t66y.com/htm_data/2001/22/3772321.html
    # https://baiduyunbo.com/?id=uSIjcjPI
    if o.netloc == 'baiduyunbo.com' and 'id' in q:
        t = 'https://m3u8.cdnpan.com/%s.m3u8' % q['id'][0]
        if not xbmcgui.Dialog().yesno('baiduyunbo', '\n'.join([url, t])):
            return {'code': ''}
        return {'title': '', 'url': t}
    url = url.split('#')[0]
    try:
        content = httpget(url)
    except Exception as e:
        return {'code': 't66y 200', 'error': str(e)}
    t = re.search(r'getElementById\(\'iframe1\'\)\.src=\'(.*?)\'', content)
    if t:
        t = t.group(1)
        return test2(t, url)
    t = re.search(r'kt_player', content)
    if t:
        return kt_player(purl, url, content)
    t = re.search(r'DPlayer\((.*?)\);', content, re.DOTALL)
    if t:
        return dplayer(purl, url, content)
    # https://t66y.com/htm_data/2001/22/3772567.html
    # https://ppse016.com/play/video.php?id=66
    t = re.search(r'video: \'(.*?)\'', content)
    if t:
        t = t.group(1)
        if not xbmcgui.Dialog().yesno('video: \'\'', '\n'.join([purl, url, t])):
            return {'code': ''}
        return {'title': '', 'url': t}
    t = re.search(r'iframe src="(.*?)"', content)
    if t:
        t = t.group(1)
        t = re.search(r'url=http(.*)', t)
        if t:
            t = 'http' + t.group(1)
        if not xbmcgui.Dialog().yesno('iframe src=""', '\n'.join([purl, url, t])):
            return {'code': ''}
        return {'title': '', 'url': t}
    # https://t66y.com/htm_data/2101/22/4300777.html
    # https://www.888dav.com/vod/168516/
    t = re.search(r'player_data={(.*?)}', content, re.DOTALL)
    if t:
        t = '{' + t.group(1) + '}'
        data = json.loads(t)
        if not xbmcgui.Dialog().yesno('player_data={}', '\n'.join([purl, url, data['url']])):
            return {'code': ''}
        return {'title': '', 'url': data['url']}
    # https://t66y.com/htm_data/2101/22/4300714.html
    # http://91.9p9.xyz/ev.php?VID=1a17DB38YziY2J0ir6fNYtYPGLmaeLsDw2tnPzZrWoNNRJo48pQTAQ
    t = re.search(r'strencode\((.*?)\);', content)
    if t:
        xbmcgui.Dialog().ok('strencode()', purl, url)
        t = '(' + t.group(1) + ')'
        return {'code': 't66y 230', 'error': url}
    return {'code': 't66y 201'}


def dplayer(purl, url, content):
    # https://t66y.com/htm_data/2101/22/4300784.html
    # https://oose026.com/play/video.php?id=5
    # https://t66y.com/htm_data/2101/22/4300615.html
    # https://baiduyunkan.com/embed/21322b748a7c633114a00ad44f7dafdf08b0c?id=1092
    import xbmcgui
    t = re.search(r'DPlayer\((.*?)\);', content, re.DOTALL)
    if not t:
        return {'code': 't66y dplayer 000', 'error': url}
    t = t.group(1)
    t1 = re.search(r'url:\s*\'(.*?)\',', t)
    if not t1:
        return {'code': 't66y dplayer 001', 'error': url}
    t1 = t1.group(1)
    t1 = urljoin(url, t1)
    if not xbmcgui.Dialog().yesno('dplayer', '\n'.join([purl, url, t1])):
        return {'code': ''}
    return {'title': '', 'url': t1}


def kt_player(purl, url, content):
    # https://t66y.com/htm_data/2101/22/4300769.html
    # https://yaoshe142.com/embed/26828
    # https://t66y.com/htm_data/2101/22/4300767.html
    # https://ppx237.com/embed/15786

    # https://github.com/ytdl-org/youtube-dl/pull/26060/files
    def getrealurl(video_url, license_code):
        urlparts = video_url.split('/')[2:]
        license = getlicensetoken(license_code)
        newmagic = urlparts[5][:32]

        for o in range(len(newmagic) - 1, -1, -1):
            new = ""
            l = (o + sum([int(n) for n in license[o:]])) % 32

            for i in range(0, len(newmagic)):
                if i == o:
                    new += newmagic[l]
                elif i == l:
                    new += newmagic[o]
                else:
                    new += newmagic[i]
            newmagic = new

        urlparts[5] = newmagic + urlparts[5][32:]
        return "/".join(urlparts)

    def getlicensetoken(license):
        modlicense = license.replace("$", "").replace("0", "1")
        center = int(len(modlicense) / 2)
        fronthalf = int(modlicense[:center + 1])
        backhalf = int(modlicense[center:])

        modlicense = str(4 * abs(fronthalf - backhalf))
        retval = ""
        for o in range(0, center + 1):
            for i in range(1, 5):
                retval += str((int(license[o + i]) + int(modlicense[o])) % 10)
        return retval

    import xbmcgui
    t = re.search(r'flashvars\s*=\s*(.*?);', content, re.DOTALL)
    if not t:
        return {'code': 't66y kt_player 000', 'error': url}
    t = t.group(1)
    video_url = re.search(r'video_url:\s*\'(.*?)\'', t)
    if not video_url:
        return {'code': 't66y kt_player 001', 'error': url}
    video_url = video_url.group(1)
    video_url_a = video_url.split('/')
    license_code = re.search(r'license_code:\s*\'(.*?)\'', t)
    if not license_code or video_url_a[0] != 'function':
        video_url_a = video_url.split('/')
        while not video_url_a[-1] or video_url_a[-1].startswith('?'):
            video_url_a = video_url_a[:-1]
        video_url2 = '/'.join(video_url_a)
        if not xbmcgui.Dialog().yesno('kt_player without license', '\n'.join([purl, url, video_url2])):
            return {'code': ''}
        return {'title': '', 'url': video_url2}
    # https://t66y.com/htm_data/2101/22/4300772.html
    # https://kkembed.kdwshell.com/embed/86519
    license_code = license_code.group(1)
    if len(license_code) != 16:
        return {'code': 't66y kt_player 010', 'error': license_code}
    if not license_code.startswith('$'):
        return {'code': 't66y kt_player 011', 'error': license_code}
    h = video_url_a[7]
    if len(h) != 32:
        return {'code': 't66y kt_player 020', 'error': video_url}
    video_url_a = getrealurl(video_url, license_code).split('/')
    while not video_url_a[-1] or video_url_a[-1].startswith('?'):
        video_url_a = video_url_a[:-1]
    video_url2 = '/'.join(video_url_a)
    if not xbmcgui.Dialog().yesno('kt_player with license', '\n'.join([purl, url, video_url2])):
        return {'code': ''}
    return {'title': '', 'url': video_url2}
